/**
 * @typedef {object} clothes
 * @property {string} name
 * @property {FC.FutureSociety} [fs] Automatically unlocked with this FS.
 * @property {boolean} [requirements]
 * @property {0|1|2|3|4} [exposure] 0: Modest, 1: Acceptable, 2: Slutty, 3: Humiliating (exposes genitals), 4: Might as well be nude
 * @property {boolean} [harsh]
 * @property {boolean} [topless]
 */

/**
 * @type {Map.<string, clothes>} The string here will be what is applied to the relevant slave property.  Slave.clothes = "a bunny outfit", not "Bunny outfit".
 */
App.Data.clothes = new Map([
	["attractive lingerie for a pregnant woman",
		{
			name: "Maternity lingerie",
			fs: "FSRepopulationFocus",
			get requirements() { return V.boughtItem.clothing.maternityLingerie === 1; },
			exposure: 2
		}
	],
	["a bunny outfit",
		{
			name: "Bunny outfit",
			fs: "FSGenderFundamentalist",
			get requirements() { return V.boughtItem.clothing.bunny === 1; },
			exposure: 1
		}
	],
	["body oil",
		{
			name: "Body oil",
			fs: "FSPhysicalIdealist",
			get requirements() { return V.boughtItem.clothing.oil === 1; },
			exposure: 4
		}
	],
	["a chattel habit",
		{
			name: "Chattel habit",
			fs: "FSChattelReligionist",
			get requirements() { return V.boughtItem.clothing.habit === 1; },
			exposure: 3
		}
	],
	["conservative clothing",
		{
			name: "Conservative clothing",
			fs: "FSPaternalist",
			get requirements() { return V.boughtItem.clothing.conservative === 1; },
			exposure: 0
		}
	],
	["harem gauze",
		{
			name: "Harem gauze",
			fs: "FSArabianRevivalist",
			get requirements() { return V.boughtItem.clothing.harem === 1; },
			exposure: 1
		}
	],
	["a huipil",
		{
			name: "Huipil",
			fs: "FSAztecRevivalist",
			get requirements() { return V.boughtItem.clothing.huipil === 1; },
			exposure: 0
		}
	],
	["a kimono",
		{
			name: "Kimono",
			fs: "FSEdoRevivalist",
			get requirements() { return (V.boughtItem.clothing.kimono === 1 || V.continent === "Japan"); },
			exposure: 0
		}
	],
	["a maternity dress",
		{
			name: "Maternity dress",
			fs: "FSRepopulationFocus",
			get requirements() { return V.boughtItem.clothing.maternityDress === 1; },
			exposure: 0,
		}
	],
	["a slutty qipao",
		{
			name: "Qipao (slutty)",
			fs: "FSChineseRevivalist",
			get requirements() { return V.boughtItem.clothing.qipao === 1; },
			exposure: 2
		}
	],
	["a long qipao",
		{
			name: "Qipao (long)",
			fs: "FSChineseRevivalist",
			get requirements() { return V.boughtItem.clothing.cultural === 1; },
			exposure: 0
		}
	],
	["Imperial Plate",
		{
			name: "Imperial Plate",
			fs: "FSNeoImperialist",
			get requirements() { return V.boughtItem.clothing.imperialarmor === 1; },
			exposure: 0
		}
	],
	["a tight Imperial bodysuit",
		{
			name: "Imperial Bodysuit",
			fs: "FSNeoImperialist",
			get requirements() { return V.boughtItem.clothing.imperialsuit === 1; },
			exposure: 2
		}
	],
	["stretch pants and a crop-top",
		{
			name: "Stretch pants and a crop-top",
			fs: "FSHedonisticDecadence",
			get requirements() { return V.boughtItem.clothing.lazyClothes === 1; },
			exposure: 0
		}
	],
	["a toga",
		{
			name: "Toga",
			fs: "FSRomanRevivalist",
			get requirements() { return V.boughtItem.clothing.toga === 1; },
			exposure: 1
		}
	],
	["Western clothing",
		{
			name: "Western clothing",
			fs: "FSPastoralist",
			get requirements() { return V.boughtItem.clothing.western === 1; },
			exposure: 3
		}
	],
	["a courtesan dress",
		{
			name: "Courtesan dress",
			fs: "FSSlaveProfessionalism",
			get requirements() { return V.boughtItem.clothing.courtesan === 1; },
			exposure: 1
		}
	],
	["a bimbo outfit",
		{
			name: "Bimbo outfit",
			fs: "FSIntellectualDependency",
			get requirements() { return V.boughtItem.clothing.bimbo === 1; },
			exposure: 2
		}
	],
	["petite admi outfit",
		{
			name: "Petite admi outfit",
			fs: "FSPetiteAdmiration",
			get requirements() { return V.boughtItem.clothing.petite === 1; },
			exposure: 0
		}
	],
	["battlearmor",
		{
			name: "Battlearmor",
			get requirements() { return V.boughtItem.clothing.military === 1; },
			exposure: 0
		}
	],
	["a military uniform",
		{
			name: "Military uniform",
			get requirements() { return V.boughtItem.clothing.military === 1; },
			exposure: 0
		}
	],
	["a red army uniform",
		{
			name: "Red Army uniform",
			get requirements() { return V.boughtItem.clothing.military === 1; },
			exposure: 0
		}
	],
	["battledress",
		{
			name: "Battledress",
			get requirements() { return V.boughtItem.clothing.military === 1; },
			exposure: 0
		}
	],
	["a biyelgee costume",
		{
			name: "Biyelgee costume",
			get requirements() { return V.boughtItem.clothing.cultural === 1; },
			exposure: 0
		}
	],
	["a dirndl",
		{
			name: "Dirndl",
			get requirements() { return V.boughtItem.clothing.cultural === 1; },
			exposure: 0
		}
	],
	["lederhosen",
		{
			name: "Lederhosen",
			get requirements() { return V.boughtItem.clothing.cultural === 1; },
			exposure: 0
		}
	],
	["a mounty outfit",
		{
			name: "Mounty outfit",
			get requirements() { return V.boughtItem.clothing.cultural === 1; },
			exposure: 0
		}
	],
	["a hanbok",
		{
			name: "Hanbok",
			get requirements() { return V.boughtItem.clothing.cultural === 1; },
			exposure: 0
		}
	],
	["a burqa",
		{
			name: "Burqa",
			get requirements() { return V.boughtItem.clothing.middleEastern === 1 || V.continent === "the Middle East"; },
			exposure: 0
		}
	],
	["a niqab and abaya",
		{
			name: "Niqab and abaya",
			get requirements() { return V.boughtItem.clothing.middleEastern === 1 || V.continent === "the Middle East"; },
			exposure: 0
		}
	],
	["a hijab and blouse",
		{
			name: "Hijab and blouse",
			get requirements() { return (V.boughtItem.clothing.conservative === 1 || V.continent === "the Middle East"); },
			exposure: 0
		}
	],
	["a burkini",
		{
			name: "Burkini",
			get requirements() { return V.boughtItem.clothing.swimwear === 1 && (V.boughtItem.clothing.swimwear === 1 || V.continent === "the Middle East"); },
			exposure: 1
		}
	],
	["a Santa dress",
		{
			name: "Santa dress",
			get requirements() { return V.boughtItem.clothing.costume === 1; },
			exposure: 2
		}
	],
	["a klan robe",
		{
			name: "Klan robe",
			get requirements() { return V.boughtItem.clothing.pol === 1; },
			exposure: 0
		}
	],
	["a slutty klan robe",
		{
			name: "Slutty klan robe",
			get requirements() { return V.boughtItem.clothing.pol === 1; },
			exposure: 2
		}
	],
	["a schutzstaffel uniform",
		{
			name: "Schutzstaffel uniform",
			get requirements() { return V.boughtItem.clothing.pol === 1; },
			exposure: 0
		}
	],
	["a slutty schutzstaffel uniform",
		{
			name: "Slutty schutzstaffel uniform",
			get requirements() { return V.boughtItem.clothing.pol === 1; },
			exposure: 2
		}
	],
	["nice business attire",
		{
			name: "Nice business attire",
			get requirements() { return V.boughtItem.clothing.career === 1; },
			exposure: 0
		}
	],
	["a nice nurse outfit",
		{
			name: "Nurse (nice)",
			get requirements() { return V.boughtItem.clothing.career === 1; },
			exposure: 0
		}
	],
	["a police uniform",
		{
			name: "Police uniform",
			get requirements() { return V.boughtItem.clothing.career === 1; },
			exposure: 0
		}
	],
	["a nice maid outfit",
		{
			name: "Maid (nice)",
			get requirements() { return V.boughtItem.clothing.career === 1 || V.PC.career === "servant" || V.PC.career === "handmaiden" || V.PC.career === "child servant"; },
			exposure: 0
		}
	],
	["a ball gown",
		{
			name: "Ballgown",
			get requirements() { return V.boughtItem.clothing.dresses === 1; },
			exposure: 0
		}
	],
	["a gothic lolita dress",
		{
			name: "Gothic lolita dress",
			get requirements() { return V.boughtItem.clothing.dresses === 1; },
			exposure: 0
		}
	],
	["a cybersuit",
		{
			name: "Cybersuit",
			get requirements() { return V.boughtItem.clothing.bodysuits === 1; },
			exposure: 0
		}
	],
	["a latex catsuit",
		{
			name: "Latex catsuit",
			get requirements() { return V.boughtItem.clothing.bodysuits === 1; },
			exposure: 1
		}
	],
	["a button-up shirt and panties",
		{
			name: "Button-up shirt and panties",
			get requirements() { return V.boughtItem.clothing.casual === 1; },
			exposure: 2
		}
	],
	["a button-up shirt",
		{
			name: "Button-up shirt",
			get requirements() { return V.boughtItem.clothing.casual === 1; },
			exposure: 3
		}
	],
	["cutoffs",
		{
			name: "Cutoffs",
			get requirements() { return V.boughtItem.clothing.casual === 1; },
			exposure: 2
		}
	],
	["jeans",
		{
			name: "Jeans",
			get requirements() { return V.boughtItem.clothing.casual === 1; },
			exposure: 2,
			topless: true
		}
	],
	["leather pants and a tube top",
		{
			name: "Leather pants and a tube top",
			get requirements() { return V.boughtItem.clothing.casual === 1; },
			exposure: 1
		}
	],
	["leather pants",
		{
			name: "Leather pants",
			get requirements() { return V.boughtItem.clothing.casual === 1; },
			exposure: 2,
			topless: true
		}
	],
	["an oversized t-shirt",
		{
			name: "Oversized t-shirt",
			get requirements() { return V.boughtItem.clothing.casual === 1; },
			exposure: 3
		}
	],
	["a sweater and cutoffs",
		{
			name: "Sweater and cutoffs",
			get requirements() { return V.boughtItem.clothing.casual === 1; },
			exposure: 0
		}
	],
	["a sweater and panties",
		{
			name: "Sweater and panties",
			get requirements() { return V.boughtItem.clothing.casual === 1; },
			exposure: 2
		}
	],
	["a sweater",
		{
			name: "Sweater",
			get requirements() { return V.boughtItem.clothing.casual === 1; },
			exposure: 3
		}
	],
	["a t-shirt and jeans",
		{
			name: "T-shirt and jeans",
			get requirements() { return V.boughtItem.clothing.casual === 1; },
			exposure: 0
		}
	],
	["a t-shirt and panties",
		{
			name: "T-shirt and panties",
			get requirements() { return V.boughtItem.clothing.casual === 1; },
			exposure: 2
		}
	],
	["a t-shirt",
		{
			name: "T-shirt",
			get requirements() { return V.boughtItem.clothing.casual === 1; },
			exposure: 3
		}
	],
	["a tank-top and panties",
		{
			name: "Tank-top and panties",
			get requirements() { return V.boughtItem.clothing.casual === 1; },
			exposure: 2
		}
	],
	["a tank-top",
		{
			name: "Tank-top",
			get requirements() { return V.boughtItem.clothing.casual === 1; },
			exposure: 3
		}
	],
	["a tube top",
		{
			name: "Tube top",
			get requirements() { return V.boughtItem.clothing.casual === 1; },
			exposure: 3
		}
	],
	["boyshorts",
		{
			name: "Boyshorts",
			get requirements() { return V.boughtItem.clothing.underwear === 1; },
			exposure: 2,
			topless: true
		}
	],
	["a bra",
		{
			name: "Bra",
			get requirements() { return V.boughtItem.clothing.underwear === 1; },
			exposure: 3
		}
	],
	["kitty lingerie",
		{
			name: "Kitty lingerie",
			get requirements() { return V.boughtItem.clothing.underwear === 1; },
			exposure: 2
		}
	],
	["panties and pasties",
		{
			name: "Panties and pasties",
			get requirements() { return V.boughtItem.clothing.underwear === 1; },
			exposure: 2
		}
	],
	["a skimpy loincloth",
		{
			name: "Skimpy loincloth",
			get requirements() { return V.boughtItem.clothing.underwear === 1; },
			exposure: 3
		}
	],
	["a thong",
		{
			name: "Thong",
			get requirements() { return V.boughtItem.clothing.underwear === 1; },
			exposure: 3,
			topless: true
		}
	],
	["pasties",
		{
			name: "Pasties",
			get requirements() { return V.boughtItem.clothing.underwear === 1; },
			exposure: 3
		}
	],
	["leather pants and pasties",
		{
			name: "Leather pants and pasties",
			get requirements() { return V.boughtItem.clothing.underwear === 1 && V.boughtItem.clothing.casual === 1; },
			exposure: 2,
		}
	],
	["a t-shirt and thong",
		{
			name: "T-shirt and thong",
			get requirements() { return V.boughtItem.clothing.underwear === 1 && V.boughtItem.clothing.casual === 1; },
			exposure: 3,
		}
	],
	["a tube top and thong",
		{
			name: "Tube top and thong",
			get requirements() { return V.boughtItem.clothing.underwear === 1 && V.boughtItem.clothing.casual === 1; },
			exposure: 3,
		}
	],
	["an oversized t-shirt and boyshorts",
		{
			name: "Oversized t-shirt and boyshorts",
			get requirements() { return V.boughtItem.clothing.underwear === 1 && V.boughtItem.clothing.casual === 1; },
			exposure: 0,
		}
	],
	["sport shorts and a sports bra",
		{
			name: "Sport shorts and a sports bra",
			get requirements() { return V.boughtItem.clothing.sports === 1; },
			exposure: 1,
		}
	],
	["sport shorts",
		{
			name: "Sport shorts",
			get requirements() { return V.boughtItem.clothing.sports === 1; },
			exposure: 2,
			topless: true
		}
	],
	["a sports bra",
		{
			name: "Sports bra",
			get requirements() { return V.boughtItem.clothing.sports === 1; },
			exposure: 3
		}
	],
	["sport shorts and a t-shirt",
		{
			name: "Sport shorts and a t-shirt",
			get requirements() { return V.boughtItem.clothing.sports === 1 && V.boughtItem.clothing.casual === 1; },
			exposure: 0
		}
	],
	["a nice pony outfit",
		{
			name: "Pony outfit (nice)",
			get requirements() { return V.boughtItem.clothing.pony === 1; },
			exposure: 1
		}
	],
	["a slutty pony outfit",
		{
			name: "Pony outfit (slutty)",
			get requirements() { return V.boughtItem.clothing.pony === 1; },
			exposure: 2
		}
	],
	["a monokini",
		{
			name: "Monokini",
			get requirements() { return V.boughtItem.clothing.swimwear === 1; },
			exposure: 3
		}
	],
	["a one-piece swimsuit",
		{
			name: "One-piece swimsuit",
			get requirements() { return V.boughtItem.clothing.swimwear === 1; },
			exposure: 1
		}
	],
	["a striped bra",
		{
			name: "Striped bra",
			get requirements() { return V.boughtItem.clothing.pantsu === 1 || V.continent === "Japan"; },
			exposure: 3
		}
	],
	["striped panties",
		{
			name: "Striped panties",
			get requirements() { return V.boughtItem.clothing.pantsu === 1 || V.continent === "Japan"; },
			exposure: 2,
			topless: true
		}
	],
	["striped underwear",
		{
			name: "Striped underwear",
			get requirements() { return V.boughtItem.clothing.pantsu === 1 || V.continent === "Japan"; },
			exposure: 2,
			topless: true
		}
	],

	// "Normal" things:
	["an apron",
		{
			name: "Apron",
			exposure: 2,
		}
	],
	["slutty jewelry",
		{
			name: "Bangles",
			exposure: 3
		}
	],
	["clubslut netting",
		{
			name: "Clubslut netting",
			exposure: 3
		}
	],
	["cutoffs and a t-shirt",
		{
			name: "Cutoffs and a t-shirt",
			exposure: 0
		}
	],
	["a comfortable bodysuit",
		{
			name: "Bodysuit",
			exposure: 1
		}
	],
	["a cheerleader outfit",
		{
			name: "Cheerleader",
			exposure: 2
		}
	],
	["a fallen nuns habit",
		{
			name: "Fallen nun",
			exposure: 3
		}
	],
	["a hijab and abaya",
		{
			name: "Hijab and abaya",
			exposure: 0
		}
	],
	["a leotard",
		{
			name: "Leotard",
			exposure: 1
		}
	],
	["a slutty maid outfit",
		{
			name: "Maid (slutty)",
			exposure: 2
		}
	],
	["a mini dress",
		{
			name: "Mini dress",
			exposure: 2
		}
	],
	["attractive lingerie",
		{
			name: "Nice lingerie",
			exposure: 2
		}
	],
	["a slutty nurse outfit",
		{
			name: "Nurse (slutty)",
			exposure: 2
		}
	],
	["overalls",
		{
			name: "Overalls",
			exposure: 1
		}
	],
	["panties",
		{
			name: "Panties",
			exposure: 2,
			topless: true
		}
	],
	["a scalemail bikini",
		{
			name: "Scalemail bikini",
			exposure: 2
		}
	],
	["a schoolgirl outfit",
		{
			name: "Schoolgirl",
			exposure: 1
		}
	],
	["a slutty outfit",
		{
			name: "Slutty outfit",
			exposure: 2
		}
	],
	["spats and a tank top",
		{
			name: "Spats and a tank top",
			exposure: 0
		}
	],
	["a string bikini",
		{
			name: "String bikini",
			exposure: 3
		}
	],
	["a succubus outfit",
		{
			name: "Succubus costume",
			exposure: 3
		}
	],
	["slutty business attire",
		{
			name: "Suit (slutty)",
			exposure: 2,
		}
	],

	/*
	["choosing her own clothes",
{
		name: "Let them choose",
	}
],
	*/
	["a halter top dress",
		{
			name: "Haltertop dress",
			exposure: 0
		}
	],
	["a slave gown",
		{
			name: "Slave gown",
			exposure: 0
		}
	],
	["chains",
		{
			name: "Chains",
			fs: "FSDegradationist",
			get requirements() { return V.boughtItem.clothing.chains === 1; },
			exposure: 4,
			harsh: true
		}
	],
	["no clothing",
		{
			name: "Go naked",
			exposure: 4,
			harsh: true
		}
	],
	["a penitent nuns habit",
		{
			name: "Penitent nun",
			exposure: 0,
			harsh: true
		}
	],
	["restrictive latex",
		{
			name: "Restrictive latex",
			exposure: 3,
			harsh: true
		}
	],
	["shibari ropes",
		{
			name: "Shibari ropes",
			exposure: 4,
			harsh: true
		}
	],
	["uncomfortable straps",
		{
			name: "Uncomfortable straps",
			exposure: 3,
			harsh: true
		}
	]
]);
/**
 * @typedef {object} slaveWear
 * @property {string} name
 * @property {FC.FutureSociety} [fs] Automatically unlocked with this FS.
 * @property {boolean} [requirements]
 * @property {boolean} [harsh]
 */

/**
 * @typedef {Map<string, slaveWear>} slaveWearCategory
 */

/** @type {Object.<string, slaveWearCategory>} */
App.Data.slaveWear = {
	collars: new Map([
		["stylish leather", {name: "Stylish leather"}],
		["satin choker", {name: "Satin choker"}],
		["silk ribbon", {name: "Silken ribbon"}],
		["heavy gold", {name: "Heavy gold"}],
		["pretty jewelry", {name: "Pretty jewelry"}],
		["nice retirement counter",
			{
				name: "Nice retirement counter",
				get requirements() {
					return V.seeAge === 1;
				}
			}
		],
		["preg biometrics",
			{
				name: "Pregnancy biometrics",
				get requirements() {
					return V.seePreg === 1;
				}
			}
		],
		["bell collar", {name: "Bell"}],
		["leather with cowbell", {name: "Cowbell"}],
		["bowtie",
			{
				name: "Bowtie collar",
				fs: "FSGenderFundamentalist",
				get requirements() {
					return V.boughtItem.clothing.bunny === 1;
				}
			}
		],
		["neck tie",
			{
				name: "Neck tie",
				fs: "FSPaternalist",
				get requirements() {
					return V.boughtItem.clothing.conservative === 1;
				}
			}
		],
		["ancient Egyptian",
			{
				name: "Ancient Egyptian",
				fs: "FSEgyptianRevivalist",
				get requirements() {
					return V.boughtItem.clothing.egypt === 1;
				}
			}
		],
		["tight steel",
			{
				name: "Tight steel",
				harsh: true
			}
		],
		["cruel retirement counter",
			{
				name: "Cruel retirement counter",
				get requirements() {
					return V.seeAge === 1;
				},
				harsh: true
			}
		],
		["uncomfortable leather",
			{
				name: "Uncomfortable leather",
				harsh: true
			}
		],
		["shock punishment",
			{
				name: "Shock punishment",
				harsh: true
			}
		],
		["neck corset",
			{
				name: "Neck corset",
				harsh: true
			}
		],
	]),

	faceAccessory: new Map([
		["porcelain mask", {name: "Porcelain mask"}],
		["cat ears", {name: "Cat ears"}],
	]),

	mouthAccessory: new Map([
		["ball gag", {name: "Ball gag"}],
		["bit gag", {name: "Bit gag"}],
		["ring gag", {name: "Ring gag"}],
		["massive dildo gag",
			{
				name: "Massive dildo gag",
				get requirements() {
					return V.boughtItem.toys.gags === 1;
				}
			}
		],
		["dildo gag", {name: "Dildo gag"}
		],
	]),

	bellyAccessories: new Map([
		["none", {name: "None"}],
		["a corset", {name: "Tight corset"}],
		["an extreme corset", {name: "Extreme corset"}],
		["a support band", {name: "Supportive band"}],
		["a small empathy belly",
			{
				name: "1st Trimester belly",
				fs: "FSRepopulationFocus",
				get requirements() {
					return V.boughtItem.clothing.belly === 1;
				}
			}
		],
		["a medium empathy belly",
			{
				name: "2nd Trimester belly",
				fs: "FSRepopulationFocus",
				get requirements() {
					return V.boughtItem.clothing.belly === 1;
				}
			}
		],
		["a large empathy belly",
			{
				name: "3rd Trimester belly",
				fs: "FSRepopulationFocus",
				get requirements() {
					return V.boughtItem.clothing.belly === 1;
				}
			}
		],
		["a huge empathy belly",
			{
				name: "3rd Trimester twins belly",
				fs: "FSRepopulationFocus",
				get requirements() {
					return V.boughtItem.clothing.belly === 1;
				}
			}
		]
	]),

	vaginalAccessories: new Map([
		["none", {name: "None"}],
		["bullet vibrator", {name: "Bullet vibrator"}],
		["smart bullet vibrator",
			{
				name: "Smart bullet vibrator",
				get requirements() {
					return V.boughtItem.toys.smartVibes === 1;
				}
			}
		],
		["dildo", {name: "Dildo"}],
		["long dildo",
			{
				name: "Long dildo",
				get requirements() {
					return V.boughtItem.toys.dildos === 1;
				}
			}
		],
		["large dildo", {name: "Large dildo"}],
		["long, large dildo",
			{
				name: "Long, large dildo",
				get requirements() {
					return V.boughtItem.toys.dildos === 1;
				}
			}
		],
		["huge dildo",
			{
				name: "Huge dildo",
				get requirements() {
					return V.boughtItem.toys.dildos === 1;
				}
			}
		],
		["long, huge dildo",
			{
				name: "Long, huge dildo",
				get requirements() {
					return V.boughtItem.toys.dildos === 1;
				}
			}
		]
	]),

	vaginalAttachments: new Map([
		["none", {name: "None"}],
		["vibrator",
			{
				name: "Vibrating attachment",
				get requirements() {
					return V.boughtItem.toys.vaginalAttachments === 1;
				}
			}
		],
		["smart vibrator",
			{
				name: "Smart vibrating attachment",
				get requirements() {
					return V.boughtItem.toys.smartVaginalAttachments === 1;
				}
			}
		]
	]),

	dickAccessories: new Map([
		["none", {name: "None"}],
		["bullet vibrator", {name: "Bullet vibrator"}],
		["smart bullet vibrator",
			{
				name: "Smart bullet vibrator",
				get requirements() {
					return V.boughtItem.toys.smartVibes === 1;
				}
			}
		]
	]),

	buttplugAttachments: new Map([
		["none", {name: "None"}],
		["tail",
			{
				name: "Tail",
				get requirements() {
					return V.boughtItem.toys.buttPlugTails === 1;
				}
			}
		],
		["fox tail",
			{
				name: "Fox tail",
				get requirements() {
					return V.boughtItem.toys.buttPlugTails === 1;
				}
			}
		],
		["cat tail",
			{
				name: "Cat tail",
				get requirements() {
					return V.boughtItem.toys.buttPlugTails === 1;
				}
			}
		],
		["cow tail",
			{
				name: "Cow tail",
				get requirements() {
					return V.boughtItem.toys.buttPlugTails === 1;
				}
			}
		]
	]),
};
/**
 * @typedef {object} slaveShoes
 * @property {string} name
 * @property {FC.FutureSociety} [fs] Automatically unlocked with this FS.
 * @property {boolean} [requirements]
 * @property {boolean} [harsh]
 * @property {number} heelHeight height in cm.  Over 4cm they may totter.  21cm and over (8 inch heels) will be painful/extreme
 * @property {number} platformHeight height in cm.  Adds to heel height.
 */

/**
 * @type {Map<string, slaveShoes>} slaveShoesCategory
 */
App.Data.shoes = new Map([ // TODO: add lift property
	["none",
		{
			name: "Barefoot",
			heelHeight: 0,
			platformHeight: 0
		}
	],
	["flats",
		{
			name: "Flats",
			heelHeight: 0,
			platformHeight: 0
		}
	],
	["pumps",
		{
			name: "Pumps",
			heelHeight: 5, // 2 inch heels
			platformHeight: 0
		}
	],
	["heels",
		{
			name: "Heels",
			heelHeight: 13, // 5 inch heels
			platformHeight: 0
		}
	],
	["boots",
		{
			name: "Thigh boots",
			heelHeight: 13, // 5 inch heels
			platformHeight: 0
		}
	],
	["extreme heels",
		{
			name: "Painfully extreme heels",
			heelHeight: 21, // 8 inch heels
			platformHeight: 0
		}
	],
	["platform shoes",
		{
			name: "Platforms",
			fs: "FSStatuesqueGlorification",
			get requirements() {
				return (V.boughtItem.shoes.heels === 1);
			},
			heelHeight: 0,
			platformHeight: 8 // 3 inch platform, no heels
		}
	],
	["platform heels",
		{
			name: "Platform heels",
			fs: "FSStatuesqueGlorification",
			get requirements() {
				return (V.boughtItem.shoes.heels === 1);
			},
			heelHeight: 13, // 8 inches, but not painful like extremes (3 inch platforms)
			platformHeight: 8
		}
	],
	["extreme platform heels",
		{
			name: "Painfully extreme platform heels",
			fs: "FSStatuesqueGlorification",
			get requirements() {
				return (V.boughtItem.shoes.heels === 1);
			},
			heelHeight: 21, // 12 inches! 8 inch heel, 4 inch platform
			platformHeight: 10
		}
	],
]);

/**
 * @typedef {object} slaveButtplugs
 * @property {string} name
 * @property {FC.FutureSociety} [fs] Automatically unlocked with this FS.
 * @property {boolean} [requirements]
 * @property {0|1|2|3} width
 * @property {0|1|2} length
 */

/**
 * @type {Map<string, slaveButtplugs>} slaveShoesCategory
 */
App.Data.buttplugs = new Map([
	["none",
		{
			name: "None",
			width: 0,
			length: 0
		}
	],
	["plug",
		{
			name: "Standard plug",
			width: 1,
			length: 1
		}
	],
	["long plug",
		{
			name: "Long plug",
			get requirements() {
				return V.boughtItem.toys.buttPlugs === 1;
			},
			width: 1,
			length: 2
		}
	],
	["large plug",
		{
			name: "Large plug",
			width: 2,
			length: 1
		}
	],
	["long, large plug",
		{
			name: "Long, large plug",
			get requirements() {
				return V.boughtItem.toys.buttPlugs === 1;
			},
			width: 2,
			length: 2
		}
	],
	["huge plug",
		{
			name: "Huge plug",
			width: 3,
			length: 1
		}
	],
	["long, huge plug",
		{
			name: "Long, huge plug",
			get requirements() {
				return V.boughtItem.toys.buttPlugs === 1;
			},
			width: 3,
			length: 2
		}
	]
]);

/**
 * @typedef {object} slaveWearChastity
 * @property {string} name
 * @property {object} updateSlave
 * @property {FC.FutureSociety} [fs]
 */

/** @type {Map<string, slaveWearChastity>} */
App.Data.chastityDevices = new Map([
	// '.value' must be a string, so using update slave so I can update multiple values.
	["none",
		{
			name: "None",
			updateSlave: {
				choosesOwnChastity: 0,
				chastityAnus: 0,
				chastityPenis: 0,
				chastityVagina: 0
			},
		}
	],
	["anal chastity",
		{
			name: "Anal chastity",
			updateSlave: {
				choosesOwnChastity: 0,
				chastityAnus: 1,
				chastityPenis: 0,
				chastityVagina: 0
			}
		}
	],
	["chastity belt",
		{
			name: "Chastity belt",
			updateSlave: {
				choosesOwnChastity: 0,
				chastityAnus: 0,
				chastityPenis: 0,
				chastityVagina: 1
			},
		}
	],
	["combined chastity belt",
		{
			name: "Combined chastity belt",
			updateSlave: {
				choosesOwnChastity: 0,
				chastityAnus: 1,
				chastityPenis: 0,
				chastityVagina: 1
			},
		}
	],
	["chastity cage",
		{
			name: "Chastity cage",
			updateSlave: {
				choosesOwnChastity: 0,
				chastityAnus: 0,
				chastityPenis: 1,
				chastityVagina: 0
			},
		}
	],
	["combined chastity cage",
		{
			name: "Combined chastity cage",
			updateSlave: {
				choosesOwnChastity: 0,
				chastityAnus: 1,
				chastityPenis: 1,
				chastityVagina: 0
			},
		}
	],
	["genital chastity",
		{
			name: "Genital chastity",
			updateSlave: {
				choosesOwnChastity: 0,
				chastityAnus: 0,
				chastityPenis: 1,
				chastityVagina: 1
			},
		}
	],
	["full chastity",
		{
			name: "Full chastity",
			updateSlave: {
				choosesOwnChastity: 0,
				chastityAnus: 1,
				chastityPenis: 1,
				chastityVagina: 1
			},
		}
	],
	["choose own chastity",
		{
			name: "Choose own chastity",
			fs: "FSRestart",
			updateSlave: {
				choosesOwnChastity: 1
			},
		}
	],
	["revoke choosing own chastity",
		{
			name: "Revoke choosing own chastity",
			fs: "FSRestart",
			updateSlave: {
				choosesOwnChastity: 0
			},
		}
	]
]);
